//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tysd.com"
#property link       "www.forex-tysd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Gray
#property indicator_color2 DeepSkyBlue
#property indicator_color3 PaleVioletRed
#property indicator_color4 DeepSkyBlue
#property indicator_color5 PaleVioletRed
#property indicator_color6 DeepSkyBlue
#property indicator_color7 PaleVioletRed
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

extern bool SkipSunday=false;

//
//
//
//
//

double PivotArray[];
double R1Array[];
double S1Array[];
double R2Array[];
double S2Array[];
double R3Array[];
double S3Array[];
double   YesterdayHigh[];
double   YesterdayLow[];
double   YesterdayClose[];
datetime YesterdayTime[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0, PivotArray); SetIndexLabel(0, "Pivot");
   SetIndexBuffer(1, R1Array);    SetIndexLabel(1, "R1");
   SetIndexBuffer(2, S1Array);    SetIndexLabel(2, "R1");
   SetIndexBuffer(3, R2Array);    SetIndexLabel(3, "R2");
   SetIndexBuffer(4, S2Array);    SetIndexLabel(4, "S2");
   SetIndexBuffer(5, R3Array);    SetIndexLabel(5, "R3");
   SetIndexBuffer(6, S3Array);    SetIndexLabel(6, "S3");
         ArrayCopySeries(YesterdayHigh,  MODE_HIGH,  Symbol(), PERIOD_D1);
         ArrayCopySeries(YesterdayLow,   MODE_LOW,   Symbol(), PERIOD_D1);
         ArrayCopySeries(YesterdayClose, MODE_CLOSE, Symbol(), PERIOD_D1);
         ArrayCopySeries(YesterdayTime,  MODE_TIME,  Symbol(), PERIOD_D1);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (Period()>PERIOD_D1) return(0);
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
      //
      //
      //
      //
      //
      
      for(int i = limit; i>=0; i--) 
      {
         if(TimeDay(Time[i]) != TimeDay(Time[i+1])) 
         {
            int y = iBarShift(NULL,PERIOD_D1,Time[i+1]); if (SkipSunday && TimeDayOfWeek(YesterdayTime[y])==0) y++;
           
              double Pivot = (YesterdayHigh[y] + YesterdayLow[y] + YesterdayClose[y]) / 3.0;
              double R1 = (2.0*Pivot) - YesterdayLow[y]; 
              double S1 = (2.0*Pivot) - YesterdayHigh[y];
              double R2 = Pivot + (YesterdayHigh[y] - YesterdayLow[y]);
              double S2 = Pivot - (YesterdayHigh[y] - YesterdayLow[y]);
              double R3 = Pivot*2.0 + (YesterdayHigh[y] - YesterdayLow[y]*2.0);
              double S3 = Pivot*2.0 - (YesterdayHigh[y]*2.0 - YesterdayLow[y]);
              
                  PivotArray[i] = Pivot;
                  R1Array[i]    = R1;
                  S1Array[i]    = S1;
                  R2Array[i]    = R2;
                  S2Array[i]    = S2;
                  R3Array[i]    = R3;
                  S3Array[i]    = S3;
         }
         else
         {
            PivotArray[i] = PivotArray[i+1];
            R1Array[i]    = R1Array[i+1];
            S1Array[i]    = S1Array[i+1];
            R2Array[i]    = R2Array[i+1];
            S2Array[i]    = S2Array[i+1];
            R3Array[i]    = R3Array[i+1];
            S3Array[i]    = S3Array[i+1];
         }            
     }
   return(0);
}